<script setup>
import { ref } from "vue";

const props = defineProps({
  selection: { type: String, default: "" },
  options: { type: Array, required: true },
});
const emit = defineEmits(["selected"]);

const inputNode = ref(null);
const editMode = ref(false);

function switchMode(mode) {
  if (mode == "edit") {
    editMode.value = true;
    inputNode.value.focus();
  } else {
    editMode.value = false;
    inputNode.value.blur();
  }
}
function updateValue() {
  const text = inputNode.value.value;
  if (text !== props.selection) emit("selected", text);
  switchMode("default");
}
</script>

<template>
  <div class="field has-addons" @mouseover="showEditBtn = !editMode" @mouseleave="showEditBtn = false">
    <div class="control">
      <input
        ref="inputNode"
        list="statuses"
        name="status"
        class="input has-overflow-ellipsis is-cursor-default has-text-black"
        type="text"
        :value="selection"
        :title="selection"
        @click="switchMode('edit')"
        @change="updateValue()"
        @keyup.enter="updateValue()"
      />
      <datalist id="statuses">
        <option v-for="(option, index) in options" :key="'option' + index" :value="option"></option>
      </datalist>
    </div>
  </div>
</template>
